# coding: utf-8

import six

from huaweicloudsdkcore.utils.http_utils import sanitize_for_serialization


class DatasourceStatistics:

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    sensitive_list = []

    openapi_types = {
        'count': 'int',
        'mysql_count': 'int'
    }

    attribute_map = {
        'count': 'count',
        'mysql_count': 'mysql_count'
    }

    def __init__(self, count=None, mysql_count=None):
        """DatasourceStatistics

        The model defined in huaweicloud sdk

        :param count: 
        :type count: int
        :param mysql_count: 
        :type mysql_count: int
        """
        
        

        self._count = None
        self._mysql_count = None
        self.discriminator = None

        if count is not None:
            self.count = count
        if mysql_count is not None:
            self.mysql_count = mysql_count

    @property
    def count(self):
        """Gets the count of this DatasourceStatistics.

        :return: The count of this DatasourceStatistics.
        :rtype: int
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this DatasourceStatistics.

        :param count: The count of this DatasourceStatistics.
        :type count: int
        """
        self._count = count

    @property
    def mysql_count(self):
        """Gets the mysql_count of this DatasourceStatistics.

        :return: The mysql_count of this DatasourceStatistics.
        :rtype: int
        """
        return self._mysql_count

    @mysql_count.setter
    def mysql_count(self, mysql_count):
        """Sets the mysql_count of this DatasourceStatistics.

        :param mysql_count: The mysql_count of this DatasourceStatistics.
        :type mysql_count: int
        """
        self._mysql_count = mysql_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                if attr in self.sensitive_list:
                    result[attr] = "****"
                else:
                    result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        import simplejson as json
        if six.PY2:
            import sys
            reload(sys)
            sys.setdefaultencoding("utf-8")
        return json.dumps(sanitize_for_serialization(self), ensure_ascii=False)

    def __repr__(self):
        """For `print`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatasourceStatistics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
